package eu.jonahbauer.chat.server.management.impl;

import eu.jonahbauer.chat.server.management.SocketManagerMXBean;
import eu.jonahbauer.chat.server.socket.SocketSupervisor;
import lombok.SneakyThrows;
import org.jetbrains.annotations.NotNull;

import java.lang.management.ManagementFactory;
import java.util.SortedSet;

public enum SocketManager implements SocketManagerMXBean {
    INSTANCE;

    @SneakyThrows
    SocketManager() {
        var server = ManagementFactory.getPlatformMBeanServer();
        server.registerMBean(new AdvancedMBean(this), SocketManagerMXBean.NAME);
    }

    @Override
    public void setCredentials(@NotNull String username, @NotNull String password) {
        SocketSupervisor.INSTANCE.setAccount(username, password);
    }

    @Override
    public void start(@NotNull String channel) {
        SocketSupervisor.INSTANCE.start(channel);
    }

    @Override
    public void stop(@NotNull String channel) throws InterruptedException {
        SocketSupervisor.INSTANCE.stop(channel);
    }

    @Override
    public void stop() throws InterruptedException {
        SocketSupervisor.INSTANCE.stop();
    }

    @Override
    public @NotNull SortedSet<@NotNull String> getChannels() {
        return SocketSupervisor.INSTANCE.getChannels();
    }
}
